HEADING=0
PITCH=0
ROLL=0
gMySensors={}

function love.load ()
	if not love.phone then
    require 'android'
  end
	if (love.phone) then
		-- orientation fixed for testing orientation sensor
		--love.phone.setRequestedOrientation(love.phone.SCREEN_ORIENTATION.SCREEN_ORIENTATION_LANDSCAPE)
		love.phone.setRequestedOrientation(love.phone.SCREEN_ORIENTATION.SCREEN_ORIENTATION_PORTRAIT)
		
		-- sensors
		for k,sensor in ipairs(love.phone.getSensorList(love.phone.SENSOR_TYPE.TYPE_ALL)) do 
			gMySensors[sensor:getLoveSensorID()] = sensor
			local name = string.lower(sensor:getName())
			--~ if (string.find(name,"accel")) then 
			if (string.find(name,"orientation")) then 
				local rate = 1
				love.phone.registerSensorListener(sensor,rate)
			end
		end
		
		-- sensor callback
		function love.phone.sensorevent(action,data) 
      HEADING=data[1] or 0
      PITCH=data[2] or 0
      ROLL=data[3] or 0
		end
		
		-- touch events
		--love.phone.enableTouchEvents()
	else
		print("needs love-android love.phone api")
	end
end


lg=love.graphics
W,H=lg:getWidth(), lg:getHeight()
L=math.min(W, H)/2
function love.draw ()
	lg.setBackgroundColor({0x83,0xc0,0xf0,255})
  lg.setColor(255,255,255,255)
	lg.print(string.format('HEADING %d', HEADING),10,10)
	lg.print(string.format('PITCH %d', PITCH),10,30)
	lg.print(string.format('ROLL %d', ROLL),10,50)

  lg.setLineWidth(2)
  lg.circle('line', W/2, H/2, L, 40)
  local c=math.rad(-90-HEADING)
  lg.line(W/2, H/2, W/2+L*math.cos(c), H/2+L*math.sin(c))

  lg.circle('line', W/2, H/2, 10, 40)
  lg.setColor(255,0,0)
  lg.circle('fill', W/2-ROLL/90*W/2, H/2-PITCH/180*H/2, 8, 40)
end

function love.update (dt)
  if love.phone.update then
    love.phone.update(dt)
  end
	--gMyTicks = love.timer.getMicroTime( )
end
